//interrupt for motor encoder
void doEncoder0A(){  //interrupt for motor encoder 0 channel A
  if (digitalRead(encoder0PinA) == HIGH) {  //look for a low-to-high on channel A
    if (digitalRead(encoder0PinB) == LOW) { //check channel B to see which way encoder is turning
      encoder0Count = encoder0Count + 1;
    } 
    else {
      encoder0Count = encoder0Count - 1;
    }
  }
  else {                                     //channel A must be a high-to-low
    if (digitalRead(encoder0PinB) == HIGH) { //check channel B to see which way encoder is turning  
      encoder0Count = encoder0Count + 1;
    } 
    else {
      encoder0Count = encoder0Count - 1;
    }
  }
  angle0 = 0.001533*encoder0Count;  //in radians .005133 converts counts to radians (1024*4)/2*pi
}

void doEncoder0B(){  //interrupt for motor encoder channel B
  if (digitalRead(encoder0PinB) == HIGH) {   // look for a low-to-high on channel B
    if (digitalRead(encoder0PinA) == HIGH) { // check channel A to see which way encoder is turning
      encoder0Count = encoder0Count + 1;
    } 
    else {
      encoder0Count = encoder0Count - 1;
    }
  }
  else {                                    // must be a high-to-low edge on on channel B
    if (digitalRead(encoder0PinA) == LOW) { // check channel B to see which way encoder is turning
      encoder0Count = encoder0Count + 1;
    } 
    else {
      encoder0Count = encoder0Count - 1;
    }
  }
  angle0 = 0.001533*encoder0Count;  //in radians .001533 converts counts to radians (1024*4)/2*pi
}

//interrupt for pendulum encoder
void doEncoder1A(){  //interrupt for motor encoder channel A
  if (digitalRead(encoder1PinA) == HIGH) {  
    if (digitalRead(encoder1PinB) == LOW) { 
      encoder1Count = encoder1Count + 1;
    } 
    else {
      encoder1Count = encoder1Count - 1;
    }
  }
  else {                                     
    if (digitalRead(encoder1PinB) == HIGH) { 
      encoder1Count = encoder1Count + 1;
    } 
    else {
      encoder1Count = encoder1Count - 1;
    }
  }
  angle1 = 0.001533*encoder1Count;  //in radians .001533 converts counts to radians (1024*4)/2*pi
}

void doEncoder1B(){  //interrupt for motor encoder channel B
  if (digitalRead(encoder1PinB) == HIGH) {  
    if (digitalRead(encoder1PinA) == HIGH) { 
      encoder1Count = encoder1Count + 1;
    } 
    else {
      encoder1Count = encoder1Count - 1;
    }
  }
  else {                                   
    if (digitalRead(encoder1PinA) == LOW) { 
      encoder1Count = encoder1Count + 1;
    } 
    else {
      encoder1Count = encoder1Count - 1;
    }
  }
  angle1 = 0.001533*encoder1Count;  //in radians .001533 converts counts to radians (1024*4)/2*pi
}

// estimate velocity, and measure current

ISR(TIMER2_OVF_vect) {  
  TCNT2 = tcnt2;  // reload the timer
  t++;
  
  // estimate velocity
  if (t == 1){  //saves previous angle data from both encoders
    angle0_previous = angle0;
    angle1_previous = angle1;
  }
  else if (t == 20){  //saves post angle data from both both encoders
    angle0_post = angle0;  
    angle1_post = angle1;
  }
  else if (t == 21){ //knowing the distance per unit time (20ms)
    velocity0 = (angle0_post - angle0_previous)*50;  //the velocity (rad/s) can be calculated
    velocity1 = (angle1_post - angle1_previous)*50;  //20ms (sampling rate)/1000ms (1 second) = 50 factor
    
    proportional = angle1 - 0;
    derivative = velocity1 - 0;
    integral = integral + proportional;
    
    t = 0;
  }
}
